#include "libmsr600.h"


int main(int argc, char *argv[])
{
    HANDLE handle = NULL;
    handle = MSR600_Open(  0x572B, 0x0483);
    if ( NULL != handle ) {
        printf("open MSR success\n");
        int ret;
        
       
        printf("\n=====start MSR600_iBtnMode()===========\n");
        BYTE transProtocol=0;
	    BYTE dataFormat=0;
        ret = MSR600_iBtnMode(handle, transProtocol, dataFormat);
        if ( CMD_OK == ret ){
            printf("MSR600_iBtnMode() success, transProtocol= %d, dataFormat=%d\n", transProtocol, dataFormat);
        } else {
            printf("MSR600_iBtnMode() failed, transProtocol= %d, dataFormat=%d\n", transProtocol, dataFormat);
        }
        printf("=====end MSR600_iBtnMode()===========\n");

        
        printf("\n=====start MSR600_iBtnEndChar()===========\n");
        BYTE endChar= 0x2B;
        ret = MSR600_iBtnEndChar(handle, endChar);
        if ( CMD_OK == ret ){
            printf(" MSR600_iBtnEndChar() success, endChar=0x%02x\n", endChar);
        } else {
            printf(" MSR600_iBtnEndChar() failed, endChar=0x%02x\n", endChar);
        }
        printf("=====end MSR600_iBtnEndChar()===========\n");


        printf("\n=====start MSR600_iBtnWithDraw()===========\n");
        BYTE withDraw[15]={'w','i','t','h','D','r','a','w'};
        int withDrawLen= 8;
        ret = MSR600_iBtnWithDraw(handle, withDraw, withDrawLen);
        if ( CMD_OK == ret ){
            printf("MSR600_iBtnWithDraw() success, withDraw=%s\n", withDraw);
        } else {
            printf("MSR600_iBtnWithDraw() failed\n");
        }
        printf("=====end MSR600_iBtnWithDraw()===========\n");

        printf("\n=====start MSR600_iBtnPrefixSuffix()===========\n");
        BYTE preFix[15] = {'p','r','e','F','i','x'};
        int preFixLen= 6;
        BYTE surFix[15] = {'s','u','r','F','i','x'};
        int surFixLen= 6;
        ret = MSR600_iBtnPrefixSuffix(handle, preFix, preFixLen, surFix, surFixLen);
        if ( CMD_OK == ret ){
            printf("MSR600_iBtnPrefixSuffix() success: prefix=%s, surfix=%s\n", preFix, surFix);
        } else {
            printf("MSR600_iBtnPrefixSuffix() failed");
        }
        printf("=====end MSR600_iBtnPrefixSuffix()===========\n");

        
 
        /*

        printf("\n=====start MSR600_iBtnReset()===========\n");        
        ret = MSR600_iBtnReset(handle);
        if ( CMD_OK == ret )
            printf("MSR600_iBtnReset success\n");
        else
            printf("MSR600_iBtnReset() failed");
        printf("=====end MSR600_iBtnReset()===========\n");
        */



        printf("\n=====start MSR600_iBtnGetOption()===========\n");
        BYTE transProtocol1;
	    BYTE dataFormat1;
	    BYTE EndChar1;
	    BYTE WithDrawLen1;
	    BYTE WithDraw1[15]={0};
	    BYTE PreFixLen1;
	    BYTE SubffixLen1;
	    BYTE PreFix1[15]={0};
	    BYTE Suffix1[15]={0};
        ret = MSR600_iBtnGetOption(
                handle,
	            &transProtocol1,
	            &dataFormat1,
	            &EndChar1,
	            &WithDrawLen1,
	            WithDraw1,
	            &PreFixLen1,
	            &SubffixLen1,
	            PreFix1,
	            Suffix1, 3000);

        if ( CMD_OK == ret ){
            printf("MSR600_iBtnGetOption() success: transProtocol=%d, dataFormat=%d,EndChar=0x%02X,WithDrawLen=%d, WithDraw=%s,PreFixLen=%d,SubffixLen=%d,PreFix=%s,Suffix=%s\n", transProtocol1,dataFormat1,EndChar1,WithDrawLen1,WithDraw1,PreFixLen1,SubffixLen1,PreFix1,Suffix1);
        } else {
            printf("MSR600_iBtnGetOption() failed");
        }
        printf("=====end MSR600_iBtnGetOption()===========\n");

        

        



        MSR600_Close(handle);
        handle = NULL;
    }  else {
        printf("open iBtn failed!!!\n");
    }
}
