#include "libmsr600.h"


int main(int argc, char *argv[])
{
    HANDLE handle = NULL;
    handle = MSR600_Open(  0x572B, 0x0483);
    if ( NULL != handle ) {
        printf("open MSR success\n");
        int ret;
        
        //get version info
        printf("\n=====start get MSR version===========\n");
        char szVersion[100] = {0};
        ret = MSR600_FwVer(handle, szVersion, 4000);
        if ( CMD_OK == ret ){
            printf("version: %s\n", szVersion);
        } else {
            printf("version: 获取版本命令失败");
        }
        printf("=====end get MSR version===========\n");


        printf("\n=====start MSR600_MagMode()===========\n");
        BYTE transProtocol = 1;
        ret = MSR600_MagMode(handle, transProtocol);
        if ( CMD_OK == ret )
            printf("MSR600_MagMode() success, transProtocol = %d\n", transProtocol);
        else
            printf("MSR600_MagMode() failed, transProtocol = %d\n", transProtocol);
        printf("=====end MSR600_MagMode()===========\n");

        
        


        
        printf("\n=====start MSR600_MagGetOption()===========\n");
        BYTE protocol;
        BYTE ssT1,esT1,ssT2,esT2, ssT3, esT3;
	    BYTE outFlagT1, outFlagT2, outFlagT3;
	    BYTE endFlag;
        ret = MSR600_MagGetOption(handle, &protocol, &ssT1, &esT1, &ssT2, &esT2, &ssT3, &esT3, &outFlagT1, &outFlagT2, &outFlagT3, &endFlag);
        if ( CMD_OK == ret )
            printf("MSR600_MagGetOption() success, protocol= %d t1SS=%c t1ES=%c t2SS=%c t2ES=%c t3SS=%c t3ES=%c outputT1=%d  outputT2=%d outputT3=%d endChar=0x%02X\n", protocol, ssT1, esT1, ssT2, esT2, ssT3, esT3, outFlagT1, outFlagT2, outFlagT3, endFlag);
        else
            printf("MSR600_MagGetOption() failed");
        printf("=====end MSR600_MagGetOption()===========\n");

        
        printf("\n=====start MSR600_MagReset()===========\n");
        ret = MSR600_MagReset(handle);
        if ( CMD_OK == ret ){
            printf("MSR600_MagReset() success\n");
        } else {
            printf("MSR600_MagReset() failed");
        }
        printf("=====end MSR600_MagReset()===========\n");


        

        



        MSR600_Close(handle);
        handle = NULL;
    }  else {
        printf("open iBtn failed!!!\n");
    }
}
