﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace MSR600_DLL_CSDemo
{
    //端口类型
    public enum PORT_TYPE
    {
        UNKNOWN_PORT = -1,
        COM_PORT = 0,
        USB_PORT = 1
    }


    ;


    public partial class Form1 : Form
    {


        

        //全局变量
        IntPtr m_devHandle = (IntPtr)(-1);
        PORT_TYPE       m_portType = PORT_TYPE.UNKNOWN_PORT;

        //返回常量
        public IntPtr INVALID_HANDLE_VALUE = (IntPtr)(-1);
        public const int CMD_OK = 0;
        public const int CMD_WRONG_PARAM = 1;
        public const int CMD_TIME_OUT = 2;
        public const int CMD_FAILED = 3;



        #region MSR600U动态库说明

        [DllImport("MSR600U_DLL.dll")]
        static extern IntPtr MSR600_Open(PORT_TYPE portType, string szPort, UInt32 baudRate, int productId, int  vendorId);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_Close(IntPtr devHandle, PORT_TYPE portType);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_FwVer(IntPtr devHandle, PORT_TYPE portType, ref byte version, Int32 waitTimeOut= 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_DecodeAutoTransData(
            IntPtr devHandle, 
            PORT_TYPE portType, 
            ref byte dType,
            ref byte   encrypMode,
            ref Int32 deviceId,
            ref byte t1Status,  ref byte t1Len, ref byte  t1Data,
            ref byte t2Status, ref byte t2Len, ref byte t2Data,
            ref byte t3Status, ref byte t3Len, ref byte  t3Data,
            ref byte iBtnStatus, ref byte iBtnCardNo, ref byte cardNoLen,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_MagMode(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte transProtocol = 1,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_MagDataFormat(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte t1SS = (byte)'%', byte t1ES = (byte)'?',
            byte t2SS = (byte)';',  byte t2ES = (byte)'?',
            byte t3SS = (byte)'+', byte t3ES = (byte)'?',
            bool outputT1 = true,
            bool outputT2 = true,
            bool outputT3 = true,
            byte endChar = 0,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_MagReset(
            IntPtr devHandle,
            PORT_TYPE portType,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_MagGetOption(
            IntPtr devHandle,
            PORT_TYPE portType,
            ref byte transProtocol,
            ref byte T1SS, ref byte pT1ES,
            ref byte T2SS, ref byte T2ES,
            ref byte T3SS, ref byte T3ES,
            ref byte OutputT1,
            ref byte OutputT2,
            ref byte OutputT3,
            ref byte EndChar,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnMode(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte transProtocol,
            byte dataFormat,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnEndChar(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte endChar= 0,
            Int32 waitTimeOut = 2500);


        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnWithDraw(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte[] withDrawData,
            Int32 dataLen,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnPrefixSuffix(
            IntPtr devHandle,
            PORT_TYPE portType,
            byte[] preFix,  Int32 preFixLen,
            byte[] surFix,   Int32 surFixLen,
            Int32 waitTimeOut = 2500);


        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnReset(
            IntPtr devHandle,
            PORT_TYPE portType,
            Int32 waitTimeOut = 2500);

        [DllImport("MSR600U_DLL.dll")]
        static extern int MSR600_iBtnGetOption(
            IntPtr devHandle,
            PORT_TYPE portType,
            ref byte TransProtocol,
            ref byte DataFormat,
            ref byte EndChar,
            ref byte WithDrawLen,
            ref byte WithDraw,
            ref byte PreFixLen,
            ref byte SubffixLen,
            ref byte PreFix,
            ref byte Suffix,
            Int32 waitTimeOut = 2500);


        #endregion

        #region 十六进制处理
        /// <summary>
        /// 字符串转16进制字节数组
        /// </summary>
        /// <param name="hexString"></param>
        /// <returns></returns>
        private  byte[] strToToHexByte(string hexString)
        {
            hexString = hexString.Replace(" ", "");
            if ((hexString.Length % 2) != 0)
                hexString += " ";
            byte[] returnBytes = new byte[hexString.Length / 2];
            for (int i = 0; i < returnBytes.Length; i++)
                returnBytes[i] = Convert.ToByte(hexString.Substring(i * 2, 2), 16);
            return returnBytes;
        }

        private int Str2Int(String hexString)
        {
            if (hexString.Length != 4)
                return 0;
            byte[] byteArr = strToToHexByte(hexString);

            return byteArr[0] * 0x100 + byteArr[1];
        }

        #endregion

        #region 定时器接收上传数据
        System.Threading.Thread t = null;
        bool m_bThreadStart = false;
        bool m_bThreadOver = true;
        public void StartAutoRecvData()
        {
            if (m_bThreadStart)
                return;

            t = new System.Threading.Thread(AutoRecvProc);
            t.IsBackground = true;
            t.Start();
            m_bThreadStart = true;          
            Console.WriteLine("start Thread");

        }
        public void StopAutoRecvData()
        {
            if (m_bThreadStart == false && m_bThreadOver == true)
                return;

            m_bThreadStart = false;
            //等待线程退出结束
            while ( !m_bThreadOver )
                System.Threading.Thread.Sleep(150);
            Console.WriteLine("StopRecvDataTime() ===end");           
            
        }

        //到达时间的时候执行事件；
        public void AutoRecvProc(object source)
        {
            byte dType = 0;
            byte encrypMode = 0;
            Int32 deviceId = 0;
            byte t1Status = 0; byte t1Len = 0; byte[] t1Data = new byte[128];
            byte t2Status = 0; byte t2Len = 0; byte[] t2Data = new byte[128];
            byte t3Status = 0; byte t3Len = 0; byte[] t3Data = new byte[128];
            byte iBtnStatus = 0; byte[] iBtnCardNo = new byte[128];
            byte cardNoLen = 0;
            int nRet;
            while (true)
            {
                if (m_bThreadStart == false)
                    break;
                m_bThreadOver = false;


                //清空显示和数据
                for (int i = 0; i < 128; i++)
                    t1Data[i] = t2Data[i] = t3Data[i] = iBtnCardNo[i] = 0;

                nRet = MSR600_DecodeAutoTransData(m_devHandle, m_portType,
                 ref dType,
                ref encrypMode,
                ref deviceId,
                ref t1Status, ref t1Len, ref t1Data[0],
                ref t2Status, ref t2Len, ref t2Data[0],
                ref t3Status, ref t3Len, ref t3Data[0],
                ref iBtnStatus, ref iBtnCardNo[0], ref cardNoLen, 1000);
                if (CMD_OK == nRet)
                {
                    //清空上次显示
                    txtTrack1.Text = txtTrack2.Text = txtTrack3.Text = "";
                    txtIBtnStatus.Text = iBtnUplaod.Text = "";

                    txtStatus.Text = "MSR600_DecodeAutoTransData() ok At " + DateTime.Now.ToLocalTime().ToString();

                    if (t1Status == 'Y')
                        txtTrack1.Text = System.Text.Encoding.UTF8.GetString(t1Data);
                    if (t2Status == 'Y')
                        txtTrack2.Text = System.Text.Encoding.UTF8.GetString(t2Data);
                    if (t3Status == 'Y')
                        txtTrack3.Text = System.Text.Encoding.UTF8.GetString(t3Data);
                    if (iBtnStatus == 0x61 || iBtnStatus == 0x62)
                    {
                        txtIBtnStatus.Text = string.Format("{0:X2}", iBtnStatus);
                        iBtnUplaod.Text = System.Text.Encoding.UTF8.GetString(iBtnCardNo);
                    }

                }
                
            }

            m_bThreadOver = true;
            Console.WriteLine("auto receive thread end!!");

        }
        #endregion

        public Form1()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
            if (comboPort.Items.Count > 0) comboPort.SelectedIndex = 0;
            if (comboBaud.Items.Count >= 2) comboBaud.SelectedIndex = 1;
            if (comboMagMode.Items.Count >= 2) comboMagMode.SelectedIndex = 1;
            if (comboMagEndChar.Items.Count > 0) comboMagEndChar.SelectedIndex = 0;
            if (cmbiBtnTransMode.Items.Count >= 2) cmbiBtnTransMode.SelectedIndex = 1;
            if (cmbiBtnDataFormat.Items.Count > 0) cmbiBtnDataFormat.SelectedIndex = 0;
            if (cmbiBtnEndChar.Items.Count > 0) cmbiBtnEndChar.SelectedIndex = 0;
        }

   

        private void btnOpenMSR_Click(object sender, EventArgs e)
        {
            //已经打开则，不重复打开
            if (INVALID_HANDLE_VALUE  != m_devHandle)
                return;
            //打开设备
            string info = "";
            if ( radCom.Checked)
            {
                //串口设备
                string comPort = comboPort.Text;
                uint baudRate = uint.Parse(comboBaud.Text);
                m_devHandle = MSR600_Open(PORT_TYPE.COM_PORT, "com3", 9600, 0, 0);
                info = "设备信息：" + comPort + string.Format("{0:D}", baudRate);
            }
            if (radUsb.Checked)
            {
                //USB设备
                int productId = Str2Int(txtProductId.Text);
                int vendorId = Str2Int(txtVendorId.Text);
                m_devHandle = MSR600_Open(PORT_TYPE.USB_PORT, "", 0, productId, vendorId);
                info = "设备信息：" + " pid="+ string.Format("{0:X4}", productId ) + " vid=" + string.Format("{0:X4}", vendorId);
            }

            if (INVALID_HANDLE_VALUE != m_devHandle)
            {


                if (radCom.Checked)
                {
                    m_portType = PORT_TYPE.COM_PORT;

                }
                if (radUsb.Checked)
                {
                    m_portType = PORT_TYPE.USB_PORT;
                }
                info += "\t打开成功";
                txtStatus.Text = info;

                MessageBox.Show("打开MSR600成功");

                //启动自动接收线程
                StartAutoRecvData();

            }
            else
            {
                info += "\t打开失败";
                txtStatus.Text = info;
                MessageBox.Show("打开MSR600失败");
            }



        }

        private void btnCloseMSR_Click(object sender, EventArgs e)
        {
            if (!m_devHandle.Equals(-1) && m_portType != PORT_TYPE.UNKNOWN_PORT)
            {
                //停止自动接收线程
                StopAutoRecvData();

                int nRet = MSR600_Close(m_devHandle, m_portType);
                if ( CMD_OK  == nRet)
                {
                    MessageBox.Show("关闭设备成功");
                    m_devHandle = INVALID_HANDLE_VALUE;
                    m_portType = PORT_TYPE.UNKNOWN_PORT;
                    txtStatus.Text = "设备关闭成功";
                } 
                
                   
            }
        }

        private void btnMsrFwVer_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            byte[] verInfo = new byte[80];
            nRet = MSR600_FwVer(m_devHandle, m_portType, ref verInfo[0]);
            if ( CMD_OK == nRet)
            {
                txtStatus.Text = System.Text.Encoding.Default.GetString(verInfo, 0, verInfo.Length); //将字节数组转换为字符串
            }
            else
            {
                string info = "获取设备版本失败";
                MessageBox.Show(info);
                txtStatus.Text = info;
            }

            //重启自动接收
            StartAutoRecvData();

        }

        private void btnMagMode_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            byte tranprotocol = (byte)comboMagMode.SelectedIndex;
            nRet = MSR600_MagMode(m_devHandle, m_portType, tranprotocol);
            string info = "";
            if (CMD_OK == nRet)
                info = "设置读卡器传输模式：" + comboMagMode.Text + " 成功";
            else
            {
                info = "设置读卡器传输模式：" + comboMagMode.Text + " 失败";
                MessageBox.Show(info);
            }
            txtStatus.Text = info;

            //重启接收线程
            StartAutoRecvData();

        }

        private void comboMagEndChar_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ( comboMagEndChar.SelectedIndex == 3)
            {
                label15.Visible = true;
                txtMagEndChar.Visible = true;
            }
            else
            {
                label15.Visible = false;
                txtMagEndChar.Visible = false;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (txtSST1.Text.Length <= 0)
                return;
            byte t1SS = (byte)txtSST1.Text.ToCharArray()[0];
            if (txtEST1.Text.Length <= 0)
                return;
            byte t1ES = (byte)txtEST1.Text.ToCharArray()[0];

            if (txtSST2.Text.Length <= 0)
                return;
            byte t2SS = (byte)txtSST2.Text.ToCharArray()[0];
            if (txtEST2.Text.Length <= 0)
                return;
            byte t2ES = (byte)txtEST2.Text.ToCharArray()[0];

            if (txtSST3.Text.Length <= 0)
                return;
            byte t3SS = (byte)txtSST3.Text.ToCharArray()[0];
            if (txtEST3.Text.Length <= 0)
                return;
            byte t3ES = (byte)txtEST3.Text.ToCharArray()[0];

            bool outputT1 = chkT1.Checked;
            bool outputT2 = chkT2.Checked;
            bool outputT3 = chkT2.Checked;
            byte endChar = 0;
            if (comboMagEndChar.SelectedIndex == 0)
                endChar = 0x58;
            if (comboMagEndChar.SelectedIndex == 1)
                endChar = 0x2B;
            if (comboMagEndChar.SelectedIndex == 2)
                endChar = 0;
            if ( comboMagEndChar.SelectedIndex == 3)
            {
                if (txtMagEndChar.Text.Length <= 0)
                    return;
                endChar = (byte)txtMagEndChar.Text.ToCharArray()[0];
            }


            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            nRet = MSR600_MagDataFormat(m_devHandle, m_portType, t1SS, t1ES, t2SS, t2ES, t3SS, t3ES, outputT1, outputT2, outputT3, endChar);
            String info = "设置读卡器: \r\nTrack1 SS=" + (char)t1SS + "\tES=" + (char)t1ES + "\r\nTrack2 SS=" + (char)t2SS + "\tES=" + (char)t2ES + "\r\nTrack3 SS=" + (char)t3SS + "\tES=" + (char)t3ES
                    + "\r\noutputT1=" + outputT1 + "\r\noutputT2=" + outputT2 + "\r\noutputT3=" + outputT3 + "\r\nendChar=" + (char)endChar;
            if (CMD_OK == nRet)           
                txtStatus.Text = "设置读卡器数据格式成功";           
            else            
                txtStatus.Text = "设置读卡器数据格式失败";
           
            MessageBox.Show(info);

            //重启接收线程
            StartAutoRecvData();

        }

        private void button3_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            nRet = MSR600_MagReset(m_devHandle, m_portType);
            if ( CMD_OK == nRet)
                txtStatus.Text = "设置读卡器数据格式成功";
            else
                txtStatus.Text = "设置读卡器数据格式失败";

            //重启接收
            StartAutoRecvData();
        }

        private void button5_Click(object sender, EventArgs e)
        {
            txtTrack1.Text = txtTrack2.Text = txtTrack3.Text = "";

            
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            byte transMode = 0;
            byte t1SS=0, t1ES= 0, t2SS = 0, t2ES = 0, t3SS = 0, t3ES = 0;
            byte outT1 = 0, outT2 = 0, outT3 = 0, endChar = 0;
            nRet = MSR600_MagGetOption(m_devHandle, m_portType, ref transMode, ref t1SS, ref t1ES,
                ref t2SS, ref t2ES, ref t3SS, ref t3ES, ref outT1, ref outT2, ref outT3, ref endChar);
            String info = "设置读卡器: \r\nTrack1 SS=" + (char)t1SS + "\tES=" + (char)t1ES + "\r\nTrack2 SS=" + (char)t2SS + "\tES=" + (char)t2ES + "\r\nTrack3 SS=" + (char)t3SS + "\tES=" + (char)t3ES
                   + "\r\noutputT1=" + outT1 + "\r\noutputT2=" + outT2 + "\r\noutputT3=" + outT3 + "\r\nendChar=" + (char)endChar;
            if (CMD_OK == nRet)
            {
                txtStatus.Text = "获取读卡器设置信息成功";
                MessageBox.Show(info+"\r\n成功");
            }
            else
            {
                txtStatus.Text = "获取读卡器设置信息失败";
                MessageBox.Show("获取读卡器设置信息失败");
            }

            StartAutoRecvData();
            
        }

        private void button6_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            byte transMode;
            byte dataFormat;
            transMode = (byte)cmbiBtnTransMode.SelectedIndex;
            dataFormat = (byte)cmbiBtnDataFormat.SelectedIndex;
            int nRet = MSR600_iBtnMode(m_devHandle, m_portType, transMode, dataFormat);
            if (CMD_OK == nRet)
                txtStatus.Text = "设置iBtn数据格式成功";
            else
                txtStatus.Text = "设置iBtn数据格式失败";

            StartAutoRecvData();
        }

        private void cmbiBtnEndChar_SelectedIndexChanged(object sender, EventArgs e)
        {
            if ( cmbiBtnEndChar.SelectedIndex == 3)
            {
                label22.Visible = true;
                txtiBtnEndChar.Visible = true;
            }
            else
            {
                label22.Visible = false;
                txtiBtnEndChar.Visible = false;
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            int nRet;
            byte endChar = 0;
            if (cmbiBtnEndChar.SelectedIndex == 0)
                endChar = 0x58;
            if (cmbiBtnEndChar.SelectedIndex == 1)
                endChar = 0x2b;
            if (cmbiBtnEndChar.SelectedIndex == 2)
                endChar = 0;
            if (cmbiBtnEndChar.SelectedIndex == 3)
            {
                if (txtiBtnEndChar.Text.Length <= 0)
                    return;
                endChar = (byte)txtiBtnEndChar.Text.ToCharArray()[0];
            }

            //尝试结束自动接收
            StopAutoRecvData();

            nRet = MSR600_iBtnEndChar(m_devHandle, m_portType, endChar);
            if (CMD_OK == nRet)
                txtStatus.Text = "设置iBtn数据包尾结束符号成功";
            else
                txtStatus.Text = "设置iBtn数据包尾结束符号失败";

            StartAutoRecvData();

        }

        private void button8_Click(object sender, EventArgs e)
        {
            int nRet;
            if (txtWithdraw.Text.Length <= 0)
                return;

            //尝试结束自动接收
            StopAutoRecvData();

            byte[] withDraw = Encoding.UTF8.GetBytes(txtWithdraw.Text);
            nRet = MSR600_iBtnWithDraw(m_devHandle, m_portType, withDraw, withDraw.Length);
            if (CMD_OK == nRet)
                txtStatus.Text = "设置iBtn withDraw 数据成功";
            else
                txtStatus.Text = "设置iBtn withDraw 数据失败";

            StartAutoRecvData();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (txtPrefix.Text.Length <= 0 || txtSuffix.Text.Length <= 0)
                return;
            byte[] prefix = Encoding.UTF8.GetBytes(txtPrefix.Text);
            byte[] suffxi = Encoding.UTF8.GetBytes(txtSuffix.Text);
            int nRet;
            //尝试结束自动接收
            StopAutoRecvData();

            nRet = MSR600_iBtnPrefixSuffix(m_devHandle, m_portType, prefix, prefix.Length, suffxi, suffxi.Length);
            if (CMD_OK == nRet)
                txtStatus.Text = "设置iBtn前后缀成功";
            else
                txtStatus.Text = "设置iBtn 前后缀失败";

            StartAutoRecvData();

        }

        private void button11_Click(object sender, EventArgs e)
        {
            //尝试结束自动接收
            StopAutoRecvData();

            int nRet;
            nRet = MSR600_iBtnReset(m_devHandle, m_portType);
            if (CMD_OK == nRet)
                txtStatus.Text = "ibtn 恢复默认设置成功";
            else
                txtStatus.Text = "ibtn 恢复默认设置失败";

            StartAutoRecvData();
        }

        private void button12_Click(object sender, EventArgs e)
        {

            //尝试结束自动接收
            StopAutoRecvData();

            byte TransProtocol = 0;
            byte DataFormat=0;
            byte EndChar=0;
            byte WithDrawLen=0;
            byte[] WithDraw = new byte[15];
            byte PreFixLen=0;
            byte SubffixLen=0;
            byte[] PreFix  = new byte[15];
            byte[] Suffix = new byte[15];

            int nRet;
            nRet = MSR600_iBtnGetOption(m_devHandle, m_portType, 
            ref TransProtocol,
            ref DataFormat,
            ref EndChar,
            ref WithDrawLen,
            ref WithDraw[0],
            ref PreFixLen,
            ref SubffixLen,
            ref PreFix[0],
            ref Suffix[0]);

            String info="";
            if (CMD_OK == nRet)
            {
                if (0 == TransProtocol)
                    info += "传输方式: Hid keyBoard" + "\r\n";
                else if (1 == TransProtocol)
                    info += "传输方式: Hid Custom" + "\r\n";
                else
                    info += "传输方式: " + TransProtocol + "\r\n";
                if (0 == DataFormat)
                    info += "数据格式：HEX" + "\r\n";
                else if ( 1== DataFormat )
                    info += "数据格式：DECIMAL" + "\r\n";
                else
                    info += "数据格式：" + DataFormat + "\r\n";
                info += "withdrawLen=" + WithDrawLen + "\r\n";
                info += "withdraw=" + System.Text.Encoding.UTF8.GetString(WithDraw)+"\r\n";

                info += "prefixLen=" + PreFixLen + "\r\n";
                info += "prefix=" + System.Text.Encoding.UTF8.GetString(PreFix) + "\r\n";

                info += "suffixLen=" + SubffixLen + "\r\n";
                info += "suffix=" + System.Text.Encoding.UTF8.GetString(Suffix) + "\r\n";

                MessageBox.Show(info);
                txtStatus.Text = "ibtn 获取设置信息成功";
            }                
            else
                txtStatus.Text = "ibtn 获取设置信息失败";

            StartAutoRecvData();
        }

        private void button10_Click(object sender, EventArgs e)
        {
            txtIBtnStatus.Text = iBtnUplaod.Text = "";
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if ((IntPtr)(-1) != m_devHandle  &&  m_portType != PORT_TYPE.UNKNOWN_PORT)
            {
                StopAutoRecvData();
                MSR600_Close(m_devHandle, m_portType);
                m_devHandle = (IntPtr)(-1);
            }
        }
    }
}
